/*
 * Copyright 2014-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.efsm.generator.test.fate;

/**
 * The test generator for EFSM-based hardware models based on the algorithm described in the article
 * <a href="http://link.springer.com/article/10.1007%2Fs10836-011-5209-8">Efficient
 * Generation of Stimuli for Functional Verification by Backjumping Across Extended FSMs</a>.
 * <br>
 * FATE is the acronym for "functional ATPG (automated test pattern generator) to traverse EFSMs".
 *
 * @author <a href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 */
public class EfsmFateTestGenerator extends AbstractFateEngine {

  /**
   * The engine ID of all {@code EfsmFateTestGenerator} instances.
   */
  public static final String ENGINE_ID = "efsm-fate-test-generator";

  /**
   * Constructs a generator.
   */
  public EfsmFateTestGenerator() {
    super(EfsmFateTestGenerator.ENGINE_ID, "EFSM.FateTestGenerator: ");
  }

  /*@Override
  protected AbstractFate getGenerator(EfsmModule module, int loopLimit, int sequenceLength,
      int sequencesNumber) {
    return new Fate(module, loopLimit, sequenceLength, sequencesNumber);
  }*/
}
