/*
 * Copyright 2014-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.cfg.printer.graphml;

import org.junit.Test;
import ru.ispras.retrascope.HdlTestFiles;
import ru.ispras.retrascope.HdlTestUtils;
import ru.ispras.retrascope.Retrascope;

import java.util.Map;

/**
 * Tests for printer from control flow graph to GraphML format.
 *
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class CfgGraphMlPrinterTestCase {

  @Test
  public void runTest() {

    final Map<String, Map<String, String>> vhdlFiles = HdlTestFiles.getVhdlProjects();

    for (final Map.Entry<String, Map<String, String>> entry : vhdlFiles.entrySet()) {
      HdlTestUtils.runVhdl(
          entry.getValue(),
          CfgGraphMlPrinter.OUT_TYPE.getId(),
          "--" + Retrascope.ENGINE_PARAM.getLongName(),
          CfgGraphMlPrinter.ENGINE_ID,
          "--" + CfgGraphMlPrinter.OUT_FILE_NAME.getLongName(),
          entry.getKey() + "-cfg.graphml");
    }
  }
}
