/*
 * Copyright 2014-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.efsm.generator.test;

import org.junit.Test;

import ru.ispras.retrascope.HdlTestUtils;
import ru.ispras.retrascope.Retrascope;
import ru.ispras.retrascope.result.test.TestModel;

import java.nio.file.Paths;
import java.util.Arrays;
import java.util.LinkedHashSet;
import java.util.Set;

/**
 * The test for {@link ru.ispras.retrascope.engine.efsm.generator.test.EfsmTestGenerator}. VHDL
 * code examples are used as inputs.
 *
 * @author <a href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 */
public class EfsmTestGeneratorVhdlTestCase {

  private static final String[] IGNORED_PATHS = new String[] {
    Paths.get("bvsample", "bvsample.vhd").toString(),
    Paths.get("example", "test.vhd").toString(),
    Paths.get("example", "driver.vhd").toString(),
    Paths.get("example", "example.vhd").toString(),
    Paths.get("b05", "b05.vhd").toString(),
    Paths.get("b12", "b12.vhd").toString(),
    Paths.get("b13", "b13.vhd").toString(),
  };

  private static final Set<String> IGNORED = new LinkedHashSet<>(Arrays.asList(IGNORED_PATHS));

  @Test
  public void generate() {
    HdlTestUtils.runVhdl(
        TestModel.TYPE.getId(),
        IGNORED,
        "--" + Retrascope.ENGINE_PARAM.getLongName(),
        EfsmTestGenerator.ENGINE_ID,
        //,"--" + Retrascope.LOG_PARAM.getLongName(), "test-generator.log",
        "--" + EfsmTestGenerator.LOOP_LIMIT_PARAMETER.getLongName(),
        "25"//25 is for b11
        /*, "--" + Retrascope.LOG_LEVEL.getLongName(), "DEBUG"*/);
  }
}
