/*
 * Copyright 2014-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.retrascope.engine.efsm.generator.test.fate;

import org.junit.Test;

import ru.ispras.retrascope.basis.Entity;
import ru.ispras.retrascope.basis.EntityType;
import ru.ispras.retrascope.engine.efsm.generator.test.AbstractEfsmTestGeneratorDummyTest;
import ru.ispras.retrascope.model.efsm.EfsmModel;
import ru.ispras.retrascope.util.Log;

import java.util.HashMap;
import java.util.Map;

/**
 * The test for {@link ru.ispras.retrascope.engine.efsm.generator.test.fate.EfsmFateTestGenerator}.
 *
 * @author <a href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 */
public class EfsmFateTestGeneratorDummyTestCase extends AbstractEfsmTestGeneratorDummyTest {

  @Test
  public void generate() {
    final EfsmFateTestGenerator generator = new EfsmFateTestGenerator();

    for (final EfsmModel efsmModel: this.efsmModels) {
      final Map<EntityType, Entity> inputs = new HashMap<>();
      inputs.put(efsmModel.getEntityType(), efsmModel);

      Log.printInfo(String.valueOf(generator.start(inputs)));
    }
  }
}
