/*
 * Copyright 2015-2016 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.smv;

import ru.ispras.retrascope.HdlTestFiles;
import ru.ispras.retrascope.Retrascope;
import ru.ispras.retrascope.SmvUtilTest;
import ru.ispras.retrascope.engine.smv.test.parser.SmvTestParser;
import ru.ispras.retrascope.engine.test.printer.testbench.TestbenchPrinterEngine;
import ru.ispras.retrascope.model.cgaa.CgaaModel;
import ru.ispras.retrascope.model.efsm.EfsmModel;
import ru.ispras.retrascope.result.testbench.TestbenchModel;

import java.io.File;
import java.util.List;
import java.util.Map;

/**
 * This class represents the test case for SmvTestParser and TestVhdlTestbenchPrinter engines.
 *
 * @author <a href="mailto:lebedev@ispras.ru">Mikhail Lebedev</a>
 */
public class SmvTestParserTestCase extends SmvUtilTest {

  @Override
  protected String[] getAdditionalTargets(final String designName) {
    final List<String> targets = commonTargets(designName);

    targets.add("--" + Retrascope.ENGINE_PARAM.getLongName());
    targets.add(SmvTestParser.ENGINE_ID);
    targets.add("--" + TestbenchPrinterEngine.OVERWRITE_EXISTING.getLongName());

    return targets.toArray(new String[targets.size()]);
  }

  @Override
  protected String getMainTarget() {
    return String.format(
        "%s%s%s%s%s",
        TestbenchModel.TYPE.getId(),
        File.pathSeparator,
        EfsmModel.TYPE.getId(),
        File.pathSeparator,
        CgaaModel.TYPE.getId());
  }

  @Override
  protected Map<String, Map<String, String>> getDesigns() {
    return HdlTestFiles.getVhdlProjects();
  }

}
