`timescale 1ns/1ps

module adder4_testbench;
  integer a, b;

  reg  [3:0] op1;
  reg  [3:0] op2;
  wire [3:0] res;
  wire overflow;

  adder4 target(.op1(op1), .op2(op2), .res(res), .overflow(overflow));

  initial begin
    $dumpvars(4, adder4_testbench);
    $display("testing adder4...");

    for(a = 0; a <= 4'b1111; a = a + 1)
    for(b = 0; b <= 4'b1111; b = b + 1)
    begin
      op1 = a;
      op2 = b;
      #10;
      $display("%d + %d = %d, overflow=%d", op1, op2, res, overflow);
    end

    $display("done");
  end
endmodule /* adder4_testbench */

